//TimeBomb, Made by MeltingPlastic (id799)
//To change the TimeBomb's time type "/timebombtime (time)"
//To change whether the TimeBomb uses lights type "/timebomblights"
//To change whether the TimeBomb uses Sound type "/timebombsound"
//you must be admin to do this.



// this is the code for managing presets.

if(isFile(%file = "config/server/RTB/modprefs.cs"))
{
	exec(%file);
}

//if the preset arnt set (first time), then set them
if($Pref::TimeBomb::TimeBombTime < 0 || $Pref::TimeBomb::TimeBombTime $= "")
{
	$Pref::TimeBomb::TimeBombTime = 5;
}
if($Pref::TimeBomb::TimeBomblights $= "")
{
	$Pref::TimeBomb::TimeBomblights = True;
}
if($Pref::TimeBomb::TimeBombsound $= "")
{
	$Pref::TimeBomb::TimeBombsound = True;
}
if($Pref::TimeBomb::Diffuserhits $= "")
{
	$Pref::TimeBomb::Defuserhits = 2;
}

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
	{
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	}

	
	RTB_registerPref("Defuser Hits","TimeBomb","$Pref::TimeBomb::Defuserhits","int 1 20","Time Bombs",25,0,0);
	RTB_registerPref("Time Bomb Time","TimeBomb","$Pref::TimeBomb::TimeBombTime","int 1 60","Time Bombs",25,0,0);
	RTB_registerPref("Time Bomb Lights","TimeBomb","$Pref::TimeBomb::TimeBomblights","bool","Time Bombs",25,0,0);
	RTB_registerPref("Time Bomb Sound","TimeBomb","$Pref::TimeBomb::TimeBombsound","bool","Time Bombs",25,0,0);
}





//USER COMMANDS:
function serverCmdtimebombtime(%client,%time)
{
	if(!%client.isAdmin && !%client.isSuperAdmin)
			return;
	
	if((!isobject(%time)) || (%time <= 0))
	{
		$Pref::TimeBomb::TimeBombTime = 5;
		messageall('',"Please Type a Valid number!  TimeBomb time is now <color:00ff00>5<color:ff0000> seconds");
	}
	
	if((%time >= 1) && (%time <= 60))
	{
		$Pref::TimeBomb::TimeBombTime = %time;
		messageall("","TimeBomb time is now<color:00ff00>" SPC %time SPC "<color:ff0000>seconds");
	}

}

function serverCmdDefuserhits(%client,%hits)
{
	if(!%client.isAdmin && !%client.isSuperAdmin)
			return;
	
	if((!isobject(%hits)) || (%hits <= 0))
	{
		$Pref::TimeBomb::Defuserhits = 2;
		messageall('',"Please Type a Valid number!  Defuser hit number is now <color:00ff00>2");
	}
	
	if((%hits >= 1) && (%hits <= 20))
	{
		$Pref::TimeBomb::Defuserhits = %time;
		messageall("","Defuser hit number is now<color:00ff00>" SPC %hits);
	}

}

function serverCmdtimebomblights(%client,%on)
{
	if(!%client.isAdmin && !%client.isSuperAdmin)
			return;
	
	if($Pref::TimeBomb::TimeBomblights == false)
	{
		$Pref::TimeBomb::TimeBomblights = true;
		messageall('',"TimeBomb lights are <color:00ff00>on.");
	}
	else
	{
		$Pref::TimeBomb::TimeBomblights = false;
		messageall("","TimeBomb lights are <color:00ff00>off.");
	}

}

function serverCmdtimebombsound(%client,%on)
{
	if(!%client.isAdmin && !%client.isSuperAdmin)
			return;
	
	if($Pref::TimeBomb::TimeBombsound == false)
	{
		$Pref::TimeBomb::TimeBombsound = true;
		messageall('',"TimeBomb sounds are <color:00ff00>on.");
	}
	else
	{
		$Pref::TimeBomb::TimeBombsound = false;
		messageall("","TimeBomb sounds are <color:00ff00>off.");
	}

}



datablock WheeledVehicleData(TimeBombCol)
{
	category = "Vehicles";
	displayName = "";
	shapeFile = "./timebomb.dts";
	emap = true;
	minMountDist = 0;
   
   numMountPoints = 0;

	maxDamage = 60;
	destroyedLevel = 60;
	energyPerDamagePoint = 1;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;
    doColorShift = true;
    colorShiftColor = "0.471 0.471 0.471 1.000";
	massCenter = "0 0 0";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	//tireEmitter = TireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 13;         // Far distance from vehicle
	cameraOffset = 7.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	



   numWheels = 0;

	// Rigid Body
	mass = 800;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 12000; //4000;       // Engine power
	engineBrake = 2000;         // Braking when throttle is 0
	brakeTorque = 50000;        // When brakes are applied
	maxWheelSpeed = 0;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0.2;

	// Energy
	maxEnergy = 5;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	//splashEmitter[0] = PropaneTankFoamDropletsEmitter;
	//splashEmitter[1] = PropaneTankFoamEmitter;
	//splashEmitter[2] = PropaneTankBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "";
	rideable = false;
		lookUpLimit = 0.65;
		lookDownLimit = 0.45;

	paintable = true;
   
  // damageEmitter[0] = PropaneTankBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   //damageEmitter[1] = PropaneTankBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

  initialExplosionProjectile = TimeBombFinalExplosionProjectile;
  // initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 100;

   finalExplosionProjectile = "";
   //finalExplosionProjectile = vehicleFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now


   minRunOverSpeed    = 30;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 1;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed
};

function TimeBombCol::onAdd(%this,%obj)
{
	Parent::onadd(%this,%obj);
	//%obj.spawnbrick = 6956;
	//echo("blabla");
	%obj.mountImage(TimeBombLightImage,2);
}

datablock ItemData(TimeBombItem)
{
	category = "Weapon";  // Mission editor category
	classname = "Weapon"; // for invantory

	//equipment = true;

	//its already a member of item namespace so dont break it
	//className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./timebombimage.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	//gui stuff
	uiName = "Time Bomb";
	iconName = "./TimeBombIcon";
	//doColorShift = true;
	//colorShiftColor = "0.200 0.200 0.200 1.000";
	
	 // Dynamic properties defined by the scripts
	image = TimeBombImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(TimeBombImage)
{
   // Basic Item properties
   shapeFile = "./TimeBombImage.dts";
   emap = false;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "-0.52 0.3 0";
   rotation = eulerToMatrix("0 0 0");
   eyeOffset = "0 0 0";
   eyeRotation = eulerToMatrix("0 0 0");

   //doColorShift = true;
	//colorShiftColor = TimeBomb.colorShiftColor;
   

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "toolImage";
   ammo = " ";
   // Projectile && Ammo.
   item = TimeBombItem;

   //melee particles shoot from eye node for consistancy
   melee = true;
   //raise your arm up or not
   armReady = true;

   //doColorShift = true;
   //colorShiftColor = TimeBombItem.colorShiftColor; //"0.200 0.200 0.200 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]	= true;

	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.5;
	stateFire[5]			= true;
	stateSequence[5]		= "fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
};
function TimeBombItem::onPickup(%this, %obj, %player)
{  
   ItemData::onPickup(%this, %obj, %player);
}


function TimeBombImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);	
		%obj.playThread(0, armreadyboth);
}


function TimeBombImage::onunMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);	
		%obj.playThread(0, root);
}

function TimeBombImage::onfire(%this, %obj, %slot)
{
	
	
	
	for(%i=0;%i<5;%i++)
	{
		%toolDB = %obj.tool[%i];
		if(%toolDB $= %this.item.getID())
		{
			%obj.tool[%i] = 0;
			%obj.weaponCount--;
			messageClient(%obj.client,'MsgItemPickup','',%i,0);
			serverCmdUnUseTool(%obj.client);
			break;
		}
	}





	%obj.Curtrans = %obj.gettransform();
	%player = %obj.client.player;
	%playertransform = %player.gettransform();
	
	%playervelocity = %obj.getvelocity();

	%vectx = getword(vectorscale(%player.geteyevector(),1.6),0);
	%vecty = getword(vectorscale(%player.geteyevector(),1.6),1);
	%vectz = getword(vectorscale(%player.geteyevector(),1.6),2);

	%startx = getword(%player.gettransform(),0);

	%starty = getword(%player.gettransform(),1);

	%startz = getword(%player.gettransform(),2);

	%startx = %startx + %vectx;
	%starty = %starty + %vecty;
	%startz = %startz +1;




	%obj.client.mine = new WheeledVehicle()
	{

	dataBlock = "TimeBombCol";

	};
	

	%second= getwords(%player.gettransform(),3,6);
	

	%obj.client.mine.setTransform(%startx SPC %starty SPC %startz SPC getwords(%playerTransform,3,6));

	
	%obj.client.mine.setvelocity(Vectoradd(vectorscale(%player.getforwardvector(),2),%player.getvelocity()));
	
	%obj.client.mine.istimebomb = 1;
	
	//resistance tward defuser, set by preset.
	%obj.client.mine.Defusehealth = $Pref::TimeBomb::Defuserhits;
	
	%obj.client.mine.owner = %obj.client;
	%thatguy = %obj.client.mine.owner.getcontrolobject();
	
	if(!isobject(%obj.client.mine.spawnbrick))
	{	
		eval("%obj.client.mine.spawnbrick = Brickgroup_" @ %obj.client.minigame.owner.Bl_id @ ".getobject(0);");
	}
	
	TimeBombTimer(%obj.client.mine,%player,%obj.client,$Pref::TimeBomb::TimeBombTime);
}










function TimeBombTimer(%mine,%toucher,%client,%time)
{
	if(isObject(%mine))
	{
		%mine.setshapename(%time);
		if(isobject(%client.minigame))
		{
			%color = getColorIDTable(%client.minigame.coloridx);
			%mine.setshapenamecolor(%color);
			
		}
		if(%time >= 1)
		{
 			schedule(1000,0,"TimeBombTimer",%mine,%toucher,%client,%time--);
			if($Pref::TimeBomb::TimeBomblights == True)
			{
				%p = new projectile()
				{
					dataBlock = TimeBombLighter;
					initialVelocity = "0 0 0";
					initialPosition = getwords(%mine.gettransform(),0,2);
					sourceObject = %obj;
					sourceSlot = %slot;
					client = %obj.client;
				};
			
		
				MissionCleanup.add(%p);
			}
			if($Pref::TimeBomb::TimeBombsound == True)
			{
			serverPlay3D(Beep_Key_Sound,%mine.getTransform());
			}
		}
	
		else
		{
 			disturbTimeBomb(%mine,%toucher,%client);
		}
	}
}

         



	function disturbTimeBomb(%TimeBombToDisturb, %SourceObject, %rigger)
	{	
		%TimeBombToDisturb.damage(%SourceObject,%TimeBombToDisturb.getworldboxcenter(),%TimeBombToDisturb.getdatablock().maxdamage);
	}









AddDamageType("TimeBombExplosion",   '<bitmap:base/client/ui/CI/bomb> %1',    '%2 <bitmap:base/client/ui/CI/bomb> %1',1,0);
datablock ExplosionData(TimeBombFinalExplosion)
{
   explosionShape = "";
   soundProfile = rocketExplodeSound;

   lifeTimeMS = 150;

   //debris = TimeBombDebris;
   //debrisNum = 1;
   //debrisNumVariance = 1;
   //debrisPhiMin = 0;
   //debrisPhiMax = 360;
   //debrisThetaMin = 0;
   //debrisThetaMax = 180;
   //debrisVelocity = 5;
   //debrisVelocityVariance = 5;

   particleEmitter = gravityRocketExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = gravityRocketExplosionRingEmitter;
   emitter[1] = gravityRocketExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 0 1";
   lightEndColor = "1 0 0 0";

   damageRadius = 8;
   radiusDamage = 170;

   impulseRadius = 15;
   impulseForce = 5000;

   playerBurnTime = 5000;

};
datablock ProjectileData(TimeBombFinalExplosionProjectile : vehicleFinalExplosionProjectile)
{
  
   radiusDamageType = $DamageType::TimeBombExplosion;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = TimeBombFinalExplosion;
   particleEmitter     = rocketTrailEmitter;

   brickExplosionRadius = 5;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;             
   brickExplosionMaxVolume = 60;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 120;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = rocketLoopSound;

   muzzleVelocity      = 120;
   velInheritFactor    = 1.0;

   armingDelay         = 0;
   lifetime            = 0;
   fadeDelay           = 4000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   explodeOnDeath = 1;

   uiName = "TimeBomb"; //naming it this way so it's next to the rocket in the alphabetized list
};


datablock ProjectileData(TimeBombLighter)
{
  
   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 200;

   hasLight    = True;
   lightRadius = 4.0;
   lightColor  = "1 0 0";
};

//////////////////////////////////////////////////////////
//Defuser Code///////////////////////////////////////////
////////////////////////////////////////////////////////


datablock ExplosionData(TimeBombDefuserExplosion : wrenchExplosion)
{
	lifetimeMS      = 180;
	lightStartColor = "0 1 0 1";
	lightEndColor   = "0 0 0 0";
};











datablock ProjectileData(TimeBombDefuserProjectile : wandProjectile)
{
	explosion      = "TimeBombDefuserExplosion";
	explodeOnDeath = 0;
	lifetime       = 100;
	
	directDamage        = 1;
};

datablock ShapeBaseImageData(TimeBombDefuserImage : wrenchImage)
{
	//armReady        = true;
	doColorShift    = true;
	colorShiftColor = "0 1 1 1";
	projectile      = "TimeBombDefuserProjectile";
	
};
datablock ItemData(TimeBombDefuserItem : wrenchItem)
{
	uiName = "Time Bomb Defuser";
	doColorShift = true;
	colorShiftColor = "0 1 1 1";
	image = TimeBombDefuserImage;
};


function TimeBombDefuserProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
{
	if(%col.istimebomb == 1)
	{
	
	%col.teleporteffect();
	%col.Defusehealth = %col.Defusehealth - 1;
	serverPlay3D(wrenchhitsound,%col.getTransform());
	
	if(%col.Defusehealth <= 0)
	{
		%col.delete();
	}
	}
}